package com.rjconsultores.ventaboletos.web.gui.controladores.ingreso;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import com.rjconsultores.ventaboletos.entidad.Banco;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderBanco;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;
import org.zkoss.zul.Intbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaBancoController")
@Scope("prototype")
public class BusquedaBancoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Banco> plwBanco;
    private MyListbox bancoList;
    private Paging pagingBanco;
    private Intbox idBanco;
    private Textbox txtNombre;
    private Intbox txtNumCuenta;
    private Textbox txtClaveSucursal;

    public MyListbox getBancoList() {
        return bancoList;
    }

    public void setBancoList(MyListbox bancoList) {
        this.bancoList = bancoList;
    }

    public Intbox getIdBanco() {
        return idBanco;
    }

    public void setIdBanco(Intbox idBanco) {
        this.idBanco = idBanco;
    }

    public Paging getPagingBanco() {
        return pagingBanco;
    }

    public void setPagingBanco(Paging pagingBanco) {
        this.pagingBanco = pagingBanco;
    }

    public PagedListWrapper<Banco> getPlwBanco() {
        return plwBanco;
    }

    public void setPlwBanco(PagedListWrapper<Banco> plwBanco) {
        this.plwBanco = plwBanco;
    }

    public Textbox getTxtClave() {
        return txtClaveSucursal;
    }

    public void setTxtClave(Textbox txtClave) {
        this.txtClaveSucursal = txtClave;
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public Intbox getTxtNumCuenta() {
        return txtNumCuenta;
    }

    public void setTxtNumCuenta(Intbox txtNumCuenta) {
        this.txtNumCuenta = txtNumCuenta;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new Banco());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        bancoList.setItemRenderer(new RenderBanco());
        bancoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Banco emp = (Banco) bancoList.getSelected();
                verPeriodo(emp);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verPeriodo(Banco emp) {
        if (emp == null) {
            return;
        }

        Map args = new HashMap();
        args.put("banco", emp);
        args.put("bancoList", bancoList);

        openWindow("/gui/ingreso/editarBanco.zul",
                Labels.getLabel("editarBancoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Banco> bancoBusqueda = new HibernateSearchObject<Banco>(Banco.class, pagingBanco.getPageSize());


//        if (idBanco != null) {
//            bancoBusqueda.addFilterEqual("bancoId", idBanco.getValue());
//        }
//      if (!txtClaveSucursal.getText().isEmpty()) {
//            bancoBusqueda.addFilterLike("numcuenta", "%" + txtClaveSucursal.getText().trim().concat("%"));
//      }
        
        
        if (txtNumCuenta != null) {
            bancoBusqueda.addFilterEqual("numcuenta", txtNumCuenta.getValue());
        }

        bancoBusqueda.addFilterLike("nombbanco", "%" + txtNombre.getText().trim().concat("%"));


        bancoBusqueda.addFilterEqual("activo", Boolean.TRUE);
        bancoBusqueda.addSortAsc("nombbanco");

        plwBanco.init(bancoBusqueda, bancoList, pagingBanco);

        if (bancoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaBancoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
